## dde-file-manager 6.5.50

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(filemanager)
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_CXX_FLAGS "")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -Werror=return-type")

# options
option(OPT_DISABLE_QDEBUG "Disable Debug Macro" OFF)
option(OPT_ENABLE_BUILD_DOCS "Build develop documents" OFF)
option(OPT_ENABLE_BUILD_UT "Buld unit tests" OFF)

# if no debug, can't out in code define key '__FUNCTION__' and so on
add_definitions(-DQT_MESSAGELOGCONTEXT)
# TODO: control it by CI. (Automation Testing)
add_definitions(-DENABLE_TESTING)

set(COMPILE_ON_V2X TRUE)
add_definitions(-DCOMPILE_ON_V2X)    # TODO: remove it
message("COMPILE ON v2X")

# check arch
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -z relro")
    add_definitions(-DARCH_MIPSEL)
endif()

# CMake modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(install_dconfig)
include(install_dbus_service)
include(GNUInstallDirs)
include(DFMInstallDirs)

# build type
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)
message("Build type:" ${CMAKE_BUILD_TYPE})

if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(BUILD_TESTING ON)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif()

message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")

# sub directories
add_subdirectory(src/apps)
add_subdirectory(src/dfm-base)
add_subdirectory(src/dfm-extension)
add_subdirectory(src/dfm-framework)
add_subdirectory(src/plugins)
add_subdirectory(src/external)
add_subdirectory(src/tools)
add_subdirectory(src/services)

# docs
if(OPT_ENABLE_BUILD_DOCS)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        add_subdirectory(docs)
    endif()
endif()

# test
if(OPT_ENABLE_BUILD_UT)
    message(STATUS "Enable testing: ${BUILD_TESTING}")
    if(BUILD_TESTING)
        enable_testing()
        add_subdirectory(tests)
    endif()
endif()

=== docs/CMakeLists.txt ===
set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)

if (DFM_BUILD_WITH_QT6)
    find_package(Qt6 COMPONENTS ToolsTools CONFIG REQUIRED)
    if (TARGET Qt6::qhelpgenerator)
        get_target_property(QHelpGenerator_EXECUTABLE Qt6::qhelpgenerator LOCATION)
        set (DOXYGEN_QHG_LOCATION "${QHelpGenerator_EXECUTABLE}")
    else ()
        message ("error: can't found qhelpgenerator from Qt6 tools.")
    endif ()
else ()
    set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
endif ()

set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.io")
set (DOXYGEN_QCH_FILE "${PROJECT_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${PROJECT_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-${QT_VERSION_MAJOR}/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "DPF_BEGIN_NAMESPACE=namespace dpf {"
    "DPF_END_NAMESPACE=}"
    "DPF_USE_NAMESPACE=using dpf;"
    "BEGEN_DFMEXT_NAMESPACE=namespace dfmext {"
    "END_DFMEXT_NAMESPACE=}"
    "USING_DFMEXT_NAMESPACE=using dfmext;"
    "DFMBASE_BEGIN_NAMESPACE=namespace dfmbase {"
    "DFMBASE_USE_NAMESPACE=}"
    "DFMBASE_USE_NAMESPACE=using dfmbase;"
    "DFMGUI_BEGIN_NAMESPACE=namespace dfmgui {"
    "DFMGUI_USE_NAMESPACE=}"
    "DFMGUI_USE_NAMESPACE=using dfmgui;"
    "DFMGLOBAL_BEGIN_NAMESPACE=namespace dfmbase::Global {"
    "DFMGLOBAL_END_NAMESPACE=}"
    "DFMGLOBAL_USE_NAMESPACE=using dfmbase::Global;"
)

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/${PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== src/dfm-base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")

if (NOT VERSION)
    set(VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 1)
endif()

# Disbale qDebug(), qInfo(), qWaring(), qCritical()
# Use qCDebug() instead of qDebug()
if(OPT_DISABLE_QDEBUG)
    add_definitions(-DDFM_DISABLE_DEBUG_MACRO)
endif()

# signals and slots keyword is disable, use Q_SIGNALS and Q_SLOTS instead
add_compile_definitions(QT_NO_SIGNALS_SLOTS_KEYWORDS)
add_compile_definitions(THUMBNAIL_TOOL_DIR="${DFM_THUMBNAIL_TOOL}")

# find source code
file(GLOB_RECURSE INCLUDE_FILES CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/include/dfm-base/*")
file(GLOB_RECURSE SRCS CONFIGURE_DEPENDS
    "./*.h"
    "./*.hpp"
    "./*.cpp"
)

# add qrc resources
set(QRC_FILES
    qrc/skin/skin.qrc
    qrc/skin/filemanager.qrc
    qrc/themes/themes.qrc
    qrc/configure.qrc
    qrc/resources/resources.qrc
    qrc/chinese2pinyin/chinese2pinyin.qrc
)

include(dfm-base-qt5.cmake)
include(dfm-base-qt6.cmake)

# install resources files
set(AssetsPath ${PROJECT_SOURCE_DIR}/assets)

FILE(GLOB SCHEMA_FILES ${AssetsPath}/gschema/*)
install(FILES ${SCHEMA_FILES} DESTINATION share/glib-2.0/schemas)
install(CODE "execute_process(COMMAND glib-compile-schemas ${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas)")

set(DLNFS_SCRIPT ${AssetsPath}/scripts/dfm-dlnfs-automount)
install(FILES ${DLNFS_SCRIPT} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/deepin/dde-file-manager)

set(DLNFS_SCRIPT_LAUNCHER ${AssetsPath}/scripts/99dfm-dlnfs-automount)
install(FILES ${DLNFS_SCRIPT_LAUNCHER} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/X11/Xsession.d)

set(DFM_DLNFS_SCRIPT_LAUNCHER
    ${AssetsPath}/scripts/dde-file-manager
    ${AssetsPath}/scripts/file-manager.sh)
install(PROGRAMS ${DFM_DLNFS_SCRIPT_LAUNCHER} DESTINATION bin)

set(Mimetypes "${ShareDir}/mimetypes")
FILE(GLOB MIMETYPE_FILES ${AssetsPath}/mimetypes/*)
install(FILES ${MIMETYPE_FILES} DESTINATION ${Mimetypes})

set(MimetypeAssociations "${ShareDir}/mimetypeassociations")
FILE(GLOB MIMETYPEASSOCIATIONS_FILES ${AssetsPath}/mimetypeassociations/*)
install(FILES ${MIMETYPEASSOCIATIONS_FILES} DESTINATION ${MimetypeAssociations})

set(Templates "${ShareDir}/templates")
FILE(GLOB TEMPLATES_FILES ${AssetsPath}/templates/*)
install(FILES ${TEMPLATES_FILES} DESTINATION ${Templates})

set(OemMenuDir "${CMAKE_INSTALL_PREFIX}/share/deepin/dde-file-manager/oem-menuextensions")
install(FILES ${AssetsPath}/.readme DESTINATION ${OemMenuDir})

set(ContexMenuDir "${CMAKE_INSTALL_PREFIX}/share/applications/context-menus")
install(FILES ${AssetsPath}/.readme DESTINATION ${ContexMenuDir})

# log viewer
set(LogViewerConfDir "${CMAKE_INSTALL_PREFIX}/share/deepin-log-viewer/deepin-log.conf.d")
install(FILES ${AssetsPath}/log/viewer/dde-file-manager.json DESTINATION ${LogViewerConfDir})

# log debug
set(LogDebugConfDir "${CMAKE_INSTALL_PREFIX}/share/deepin-debug-config/deepin-debug-config.d")
install(FILES ${AssetsPath}/log/debug/org.deepin.file-manager.json DESTINATION ${LogDebugConfDir})

INSTALL_DCONFIG("org.deepin.dde.file-manager.json")
INSTALL_DCONFIG("org.deepin.dde.file-manager.plugins.json")
INSTALL_DCONFIG("org.deepin.dde.file-manager.view.json")
INSTALL_DCONFIG("org.deepin.dde.file-manager.animation.json")

=== src/apps/dde-file-dialog-wayland/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Compatibility history issues, GTK check app name
project(dde-select-dialog-wayland)

configure_file(
    "${APP_SOURCE_DIR}/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
    )

set(SRCS
    main.cpp
)

find_package(Qt6 COMPONENTS Core)
add_executable(${PROJECT_NAME} ${SRCS})

target_link_libraries(
    ${PROJECT_NAME}
    DFM6::base
    DFM6::framework
)

install(TARGETS ${PROJECT_NAME} DESTINATION bin)
install(FILES data/com.deepin.filemanager.filedialog_wayland.service DESTINATION share/dbus-1/services)

=== src/external/dde-shell-plugins/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

add_subdirectory(panel-desktop)

=== src/services/accesscontrol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-filemanager-accesscontrol)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AccessControl_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.AccessControl.xml)

find_package(PkgConfig REQUIRED)
find_package(Qt6 COMPONENTS DBus REQUIRED)

FILE(GLOB FILEOPERATIONS_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.policy"
    )

# qt6_generate_dbus_interface(
#    accesscontroldbus.h
#    ${AccessControl_XML}
#    OPTIONS -M -S
# )

qt6_add_dbus_adaptor(FILEOPERATIONS_FILES ${AccessControl_XML}
    accesscontroldbus.h AccessControlDBus)

add_library(${PROJECT_NAME}
    SHARED
    ${FILEOPERATIONS_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../)


pkg_search_module(crypt
    REQUIRED
    libcryptsetup
    IMPORTED_TARGET
)
pkg_check_modules(PolkitAgent
    REQUIRED
    polkit-agent-1
    IMPORTED_TARGET
)
pkg_check_modules(PolkitQt6
    REQUIRED
    polkit-qt6-1
    IMPORTED_TARGET
)

target_link_libraries(${PROJECT_NAME}
    DFM6::base
    PkgConfig::crypt
    PkgConfig::PolkitAgent
    PkgConfig::PolkitQt6
    Qt6::DBus
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/system/)
install(FILES org.deepin.filemanager.accesscontrol.conf DESTINATION share/dbus-1/system.d/)

set(PolicyDir "${CMAKE_INSTALL_PREFIX}/share/polkit-1/actions")
install(FILES polkit/org.deepin.filemanager.accesscontrol.policy DESTINATION ${PolicyDir})

=== src/services/diskencrypt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(BIN_NAME "deepin-diskencrypt-service")
project(${BIN_NAME})

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(DiskEncrypt_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.DiskEncrypt.xml)

find_package(Qt6 REQUIRED COMPONENTS Core Concurrent DBus)
find_package(deepin-qdbus-service REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(CryptSetup REQUIRED libcryptsetup)
pkg_check_modules(DevMapper REQUIRED devmapper)
pkg_check_modules(PolkitAgent REQUIRED polkit-agent-1 IMPORTED_TARGET)
pkg_check_modules(PolkitQt6 REQUIRED polkit-qt6-1 IMPORTED_TARGET)

add_definitions(-DSERVICE_CONFIG_DIR="${CMAKE_INSTALL_PREFIX}/share/deepin-service-manager/")

file(GLOB_RECURSE SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

# generate dbus xml and adaptor
# DBus: DiskEncryptDBus
qt6_generate_dbus_interface(
   dbus/diskencryptsetup.h
   ${DiskEncrypt_XML}
   OPTIONS -M -S
)
qt6_add_dbus_adaptor(SRCS
                     ${DiskEncrypt_XML}
                     dbus/diskencryptsetup.h
                     DiskEncryptSetup)


add_executable(${BIN_NAME}
    ${SRCS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt6::Core
    Qt6::Concurrent
    Qt6::DBus
    DFM6::base
    PkgConfig::PolkitAgent
    PkgConfig::PolkitQt6
    deepin-qdbus-service
    ${CryptSetup_LIBRARIES}
    ${DevMapper_LIBRARIES}
)

target_include_directories(${BIN_NAME}
    PUBLIC
    ${PROJECT_SOURCE_DIR}
    ${CryptSetup_INCLUDE_DIRS}
)

install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/other/)
install(FILES org.deepin.filemanager.diskencrypt.conf DESTINATION share/dbus-1/system.d/)
install(FILES org.deepin.Filemanager.DiskEncrypt.service DESTINATION share/dbus-1/system-services/)
install(FILES ${CMAKE_SOURCE_DIR}/assets/rules/99-dfm-encrypt.rules DESTINATION /etc/udev/rules.d)

set(PolicyDir "${CMAKE_INSTALL_PREFIX}/share/polkit-1/actions")
install(FILES polkit/policy/org.deepin.filemanager.diskencrypt.policy
    DESTINATION ${PolicyDir})
install(FILES polkit/rules/99-dde-file-manager-encrypt.pkla
    DESTINATION /etc/polkit-1/localauthority/10-vendor.d)

=== src/services/sharecontrol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-filemanager-sharecontrol)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(ShareControl_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.ShareControl.xml)

FILE(GLOB FILEOPERATIONS_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.xml"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.policy"
    )

find_package(PkgConfig REQUIRED)
find_package(Qt6 COMPONENTS DBus REQUIRED)
pkg_check_modules(PolkitAgent REQUIRED polkit-agent-1)
pkg_check_modules(PolkitQt6 REQUIRED polkit-qt6-1)

# qt6_generate_dbus_interface(
#    sharecontroldbus.h
#    ${ShareControl_XML}
#    OPTIONS -M -S
# )

qt6_add_dbus_adaptor(FILEOPERATIONS_FILES ${ShareControl_XML}
    sharecontroldbus.h ShareControlDBus)

add_library(${PROJECT_NAME}
    SHARED
    ${FILEOPERATIONS_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../)

target_link_libraries(${PROJECT_NAME}
    DFM6::base
    Qt6::DBus
    ${PolkitAgent_LIBRARIES}
    ${PolkitQt6_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/system/)
install(FILES org.deepin.filemanager.usersharemanager.conf DESTINATION share/dbus-1/system.d/)
INSTALL_DBUS_SERVICE(org.deepin.Filemanager.UserShareManager root)

set(PolicyDir "${CMAKE_INSTALL_PREFIX}/share/polkit-1/actions")
install(FILES polkit/org.deepin.filemanager.usersharemanager.policy DESTINATION ${PolicyDir})

#execute_process(COMMAND qdbuscpp2xml sharecontroldbus.h -o ./sharecontroldbus.xml
#    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
#execute_process(COMMAND qdbusxml2cpp -i ../sharecontroldbus.h -c ShareControlAdapter -l ShareControlDBus -a dbusadapter/sharecontrol_adapter sharecontroldbus.xml
#    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/services/textindex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-filemanager-textindex)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(TextIndex_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.TextIndex.xml)
set(FULL_TEXT_PATH "${CMAKE_SOURCE_DIR}/3rdparty/fulltext")

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.xml"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.policy"
    "${FULL_TEXT_PATH}/*.cpp"
    "${FULL_TEXT_PATH}/*.h"
    "${CMAKE_SOURCE_DIR}/include/dfm-base/dfm_log_defines.h"
    )

find_package(PkgConfig REQUIRED)
find_package(Qt6 COMPONENTS Core DBus Gui REQUIRED)
find_package(Dtk6 COMPONENTS Core)

qt6_generate_dbus_interface(
   textindexdbus.h
   ${TextIndex_XML}
   OPTIONS -M -S
)

qt6_add_dbus_adaptor(SRC_FILES ${TextIndex_XML}
    textindexdbus.h TextIndexDBus)

#full-text search dependences
pkg_check_modules(Lucene REQUIRED IMPORTED_TARGET liblucene++ liblucene++-contrib)
pkg_check_modules(Docparser REQUIRED IMPORTED_TARGET docparser)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(PCRE REQUIRED libpcre2-8)

add_library(${PROJECT_NAME}
    SHARED
    ${SRC_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../)

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${GLIB_INCLUDE_DIRS}
        ${PCRE_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/include
        ${FULL_TEXT_PATH}/..
)

target_link_libraries(${PROJECT_NAME}
    Qt6::Core
    Qt6::DBus
    Qt6::Gui
    Dtk6::Core
    ${GLIB_LIBRARIES}
    ${PCRE_LIBRARIES}
    PkgConfig::Lucene
    PkgConfig::Docparser
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/user/)

=== tests/apps/dde-file-manager/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 工程名称
project(test-dde-file-manager)

# 依赖包
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
REQUIRED)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
)

#单元测试文件
FILE(GLOB_RECURSE UT_SRC "./*/*.cpp")

# 源文件
set(SRCS
    main.cpp
)

add_executable(${PROJECT_NAME} ${SRCS})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    -lpthread
)

add_test(
  NAME dde-file-manager
  COMMAND $<TARGET_FILE:${PROJECT_NAME}>
)

=== src/apps/dde-file-manager-preview/libdfm-preview/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dfm-preview)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt6 COMPONENTS Core REQUIRED)

FILE(GLOB_RECURSE FILEPREVIEW_FILES CONFIGURE_DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    )

add_library(${PROJECT_NAME}
    SHARED
    ${FILEPREVIEW_FILES}
)

set(VERSION 1.8.2)
add_definitions(-DVERSION=\"${VERSION}\")

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ./)

target_link_libraries(${PROJECT_NAME}
    DFM6::base
    DFM6::framework
)

#install library file
install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${DFM_PLUGIN_PREVIEW_DIR})
INSTALL_DCONFIG("org.deepin.dde.file-manager.preview.json")

=== src/external/dde-shell-plugins/panel-desktop/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ds-panel-desktop )

configure_file(
    "${APP_SOURCE_DIR}/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
)

find_package(DDEShell REQUIRED)
find_package(Qt6 COMPONENTS DBus REQUIRED)

FILE(GLOB_RECURSE FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

add_library(ds-panel-desktop SHARED
    ${FILES}
)

target_compile_definitions(${PROJECT_NAME}
 PRIVATE
     DDE_LAUNCHPAD_VERSION=${CMAKE_PROJECT_VERSION}
 )

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}
        ${Qt6Widgets_PRIVATE_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    Dde::Shell
    DFM6::base
    DFM6::framework
    Qt6::DBus
)

ds_install_package(PACKAGE org.deepin.ds.desktop TARGET ds-panel-desktop)

# dbus
install(FILES data/com.deepin.dde.desktop.service DESTINATION share/dbus-1/services)

# computer and trash
install(FILES data/applications/dfm-open.sh DESTINATION bin/)
install(FILES data/applications/dde-computer.desktop DESTINATION share/applications/)
install(FILES data/applications/dde-trash.desktop DESTINATION share/applications/)
install(FILES data/applications/dde-home.desktop DESTINATION share/applications/)

=== debian/changelog ===
dde-file-manager (6.5.50) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Wed, 14 May 2025 16:41:55 +0800

dde-file-manager (6.5.49) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 08 May 2025 20:06:43 +0800

dde-file-manager (6.5.48) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Tue, 29 Apr 2025 17:39:55 +0800

dde-file-manager (6.5.47) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 24 Apr 2025 19:18:14 +0800

dde-file-manager (6.5.46) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 17 Apr 2025 13:12:52 +0800

dde-file-manager (6.5.45) unstable; urgency=medium

 * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 10 Apr 2025 19:50:17 +0800

dde-file-manager (6.5.44) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Wed, 02 Apr 2025 15:53:07 +0800

dde-file-manager (6.5.43) unstable; urgency=medium

  * Feature additions (view mode switching, FileStatisticsJob)
  * UI fixes (dialog buttons, password input, element dimensions)
  * Performance improvements (memory management, text indexing)
  * Code refactoring (URL validation, file checks)
  * Localization updates (multiple translations)
  * Core improvements (MIME initialization, URL handling) 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 27 Mar 2025 14:13:23 +0800

dde-file-manager (6.5.42) unstable; urgency=medium

  * fix bugs 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 21 Mar 2025 15:24:59 +0800

dde-file-manager (6.5.41) unstable; urgency=medium

  * fix bugs 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 20 Mar 2025 21:20:03 +0800

dde-file-manager (6.5.40) unstable; urgency=medium

  * Enhance URL determination, fix UI errors, improve file operations, update translations, and implement features like mount point normalization, drag-and-drop enhancements, and file copy synchronization with range support, alongside various UI and localization improvements. 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 20 Mar 2025 19:10:05 +0800

dde-file-manager (6.5.39) unstable; urgency=medium

  * Prevent UI flickering during sidebar expansion, improve Unicode sorting in file comparison, simplify file info creation and speedtimer management, ensure proper initialization, and replace abort() with Q_ASSERT_X for plugin loading failures. 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 12 Mar 2025 20:26:26 +0800

dde-file-manager (6.5.38) unstable; urgency=medium

  * fix bug

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 11 Mar 2025 18:54:03 +0800

dde-file-manager (6.5.37) unstable; urgency=medium

  * Optimize file dialog and fix issues including extension search, directory size display, font handling, tag widget behavior, partition access, icon rendering, and sorting enhancements with full-width character and directory support.

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 11 Mar 2025 14:27:12 +0800

dde-file-manager (6.5.36) unstable; urgency=medium

  * Enhance translation support in dde-file-manager and introduce Qt6 plugin version compatibility checks.

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 07 Mar 2025 14:31:42 +0800

dde-file-manager (6.5.35) unstable; urgency=medium

  * This update addresses multiple issues including encryption/decryption processes, device mounting, UI improvements, error handling, and permission checks, introduces features like crypttab header support and blur effects, and migrates from Qt5 to Qt6. 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 06 Mar 2025 20:41:48 +0800

dde-file-manager (6.5.34) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 28 Feb 2025 17:33:52 +0800

dde-file-manager (6.5.33) unstable; urgency=medium

  * revert a commit for CI

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 21 Feb 2025 17:40:35 +0800

dde-file-manager (6.5.32) unstable; urgency=medium

  * fix bugs 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 21 Feb 2025 15:53:18 +0800

dde-file-manager (6.5.31) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 20 Feb 2025 21:24:09 +0800

dde-file-manager (6.5.30) unstable; urgency=medium

  * fix: Resolved the issue where the prompt message was incomplete during the first SFTP access
  * feat: Add slider configuration with custom value list
  * fix: the frontend logic of decrypt device.
  * refactor: Improve sidebar item validation and drag-and-drop handling
  * fix: Disable titlebar menu for file dialog and improve window handling
  * fix: Fixed the issue of failing to rename multiple files simultaneously
  * feat: refact the encrypt backend
  * fix: Fixed the issue where changing the password only responded the first time

 -- Zhang Sheng <zhangsheng@uniontech.com>  Sat, 15 Feb 2025 15:30:10 +0800

dde-file-manager (6.5.29) unstable; urgency=medium

  * fix: random event registration failure due to plugin startup order
  * chore: remove redunant comments
  * fix: icon scaling and improve performance in item delegates
  * fix: Resolve display issue with Close All button in property dialog for multiple directory selection.
  * fix: sort "send-to-bluetooth" option in canvas menu
  * feat: add tooltip for multi-line display in property dialog
  * fix: update path handling in isMptOfDevice method
  * fix: Modify the history record logic of the address bar connecting to the remote file server.
  * fix: Fixed the issue of not entering the username and password during mount, and directly closing the authentication window, prompting for incorrect information.
  * fix: improve drag and drop permission checks
  * fix: add conditional compilation for window and file plugins
  * fix: ensure file info attributes are properly retrieved
  * fix: improve icon cache refresh mechanism
  * feat: Impl OpenFiles extension


=== debian/control ===
Source: dde-file-manager
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 cmake,
 doxygen,
 debhelper (>=9),
 pkg-config,
 libffmpegthumbnailer-dev,
 libpolkit-agent-1-dev,
 dde-tray-loader-dev,
 libtag1-dev,
 libdmr-dev,
 libicu-dev,
 libxcb-ewmh-dev,
 libdeepin-pdfium-dev,
 libssl-dev,
 libgtest-dev,
 libgmock-dev,
 liblucene++-dev,
 libdocparser-dev,
 libboost-filesystem-dev,
 libsecret-1-dev,
 libpoppler-cpp-dev,
 libcryptsetup-dev,
 libpcre2-dev,
 libdde-shell-dev (>= 0.0.10),
 deepin-desktop-base | deepin-desktop-server | deepin-desktop-device,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 qt6-multimedia-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-declarative-dev,
 qt6-5compat-dev,
 libdtk6widget-dev,
 libdtk6gui-dev,
 libdtk6core-dev,
 libdtk6core-bin,
 libdtk6declarative-dev,
 libdfm6-io-dev,
 libdfm6-mount-dev,
 libdfm6-burn-dev,
 libpolkit-qt6-1-dev,
 libxcb-xfixes0-dev (>= 1.10~),
 libopenjp2-7-dev,
 liblcms2-dev,
 libdeepin-service-framework-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: dde-desktop
Architecture: any
Depends: 
 ${shlibs:Depends}, 
 ${misc:Depends}, 
 libdde-file-manager (=${binary:Version}),
 libqt6sql6-sqlite,
 qt6-translations-l10n,
 libimageeditor6 | hello
Conflicts: dde-workspace (<< 2.90.5), dde-file-manager-oem, dde-desktop-plugins
Replaces: dde-file-manager-oem, dde-file-manager (<< 6.0.1), dde-desktop-plugins
Recommends: deepin-screensaver
Description: deepin desktop-environment - desktop module
 Deepin Desktop Environment (DDE) - desktop module.

Package: dde-file-manager
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdde-file-manager (=${binary:Version}),
 socat,
 cryfs,
 dde-device-formatter,
 libblockdev-crypto2 | libblockdev-crypto3,
 dde-file-manager-services-plugins (=${binary:Version}),
 qml6-module-qtquick-controls,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 tpm2-abrmd,
 libtss2-tcti-pcap0,
 libtss2-tcti-tabrmd0,
 libusec-recoverykey | hello
Replaces: dde-file-manager-oem, dde-desktop (<< 6.0.1),
 dde-file-manager-preview,
 dde-file-manager-preview-plugins,
 dde-file-manager-plugins,
 dde-file-manager-daemon-plugins,
 dde-file-manager-common-plugins
Conflicts: dde-file-manager-preview,
 dde-file-manager-preview-plugins,
 dde-file-manager-plugins,
 dde-file-manager-daemon-plugins,
 dde-file-manager-common-plugins
Recommends: avfs, samba, deepin-anything-server
Description: File manager front end
 File manager front-end of Deepin OS

Package: libdde-file-manager
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libpoppler-cpp0v5 (>= 0.48.0),
 gvfs-backends (>=1.27.3),
 cryptsetup,
 libdfm-extension (=${binary:Version}),
 dlnfs | hello
Multi-Arch: same
Description: DDE File Manager core librarys
 This package contains the shared libraries.
Replaces: dfmplugin-disk-encrypt
Conflicts: dfmplugin-disk-encrypt

Package: dde-disk-mount-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plugin of dde-dock
 Disk mount plugin of dde-dock which is created by dde-file-manager

Package: libdfm-extension
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extension library of dde-file-manager
 Extension library of dde-file-manager which is provided for third parties

Package: dde-file-manager-services-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin desktop-environment - deepin-service-manager plugins module
 Deepin Desktop Environment (DDE) - deepin-service-manager plugins module.
 
Package: libdfm-extension-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdfm-extension (=${binary:Version})
Description: Development package for libdfm-extension
 This package contains the header files and pkgconfig
 of libdfm-extension

Package: dde-file-manager-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dde-file-manager (=${binary:Version}),
 libdfm6-io-dev, libdfm6-mount-dev, libdfm6-burn-dev
Description: DDE File Manager Devel library
 This package contains the header files and static libraries
 of dde-file-manager
